﻿Module Module1

    Function BinarySearch(ByRef Arr() As String, ByVal Target As String, Optional ByVal Reset As Boolean = False) As Integer
        Static St As Integer = 0, En As Integer = UBound(Arr)
        If Reset Then
            St = 0
            En = UBound(Arr)
        End If
        ' شرط توقف: العثور على عنصر البحث في خانة البداية أو النهاية
        If Arr(St) = Target Then Return St
        If Arr(En) = Target Then Return En
        Dim Mdl As Integer = (St + En + 1) \ 2
        Select Case Arr(Mdl)
            Case Target
                'شرط توقف: العثور على نصّ البحث في خانة المنتصف
                Return Mdl
            Case Is < Target
                ' الهدف أكبر من قيمة خانة المنتصف.. شرط توقف: خانة المنتصف 
                'هي خانة النهاية أو تسبقها بخانة، مما يعني أنه لا يوجد بينهما 
                ' خانات نبحث فيها سنعيد سالب رقم الخانة التالية لخانة المنتصف
                If En - Mdl < 2 Then Return -(Mdl + 1)
                ' البحث في الجزء الأخير من المصفوفة الحاليّة
                St = Mdl + 1
                En -= 1
                ' نتيجة البحث هي ناتج البحث في الجزء الأخير من المصفوفة
                Return BinarySearch(Arr, Target)
            Case Else ' الهدف أصغر من قيمة خانة المنتصف
                ' شرط توقف: خانة المنتصف هي خانة البداية أو تليها  بخانة مما يعني 
                ' أنه لا يوجد بينهما خانات نبحث فيها سنعيد سالب رقم خانة المنتصف 
                If Mdl - St < 2 Then Return -Mdl
                ' البحث في الجزء الأوّل من المصفوفة الحاليّة
                St += 1
                En = Mdl - 1
                ' نتيجة البحث هي ناتج البحث في النصف الأوّل من المصفوفة
                Return BinarySearch(Arr, Target)
        End Select
    End Function

    Sub QuickSort(ByRef Arr() As String, Optional ByVal SortDirection As Integer = 0, Optional ByVal St As Integer = 0, Optional ByVal En As Integer = -1)
        If En = -1 Then En = UBound(Arr)
        Dim I As Integer, LAC As Integer = St, Temp As String
        For I = St + 1 To En
            If (SortDirection = 1) Xor (Arr(I) <= Arr(St)) Then
                LAC += 1
                ' تبادل قيمتي الخانتين، إذا كانتا بالفعل خانتين مختلفتين
                If LAC <> I Then
                    Temp = Arr(LAC)
                    Arr(LAC) = Arr(I)
                    Arr(I) = Temp
                End If
            End If
        Next
        ' تبادل قيمتي الخانة المرجعيّة مع آخر أصغر رقم
        If LAC <> St Then
            Temp = Arr(LAC)
            Arr(LAC) = Arr(St)
            Arr(St) = Temp
        End If
        If LAC - St > 1 Then
            QuickSort(Arr, SortDirection, St, LAC - 1)
        End If
        If En - LAC > 1 Then
            QuickSort(Arr, SortDirection, LAC + 1, En)
        End If
    End Sub

    Function BinarySearch2(ByRef Arr() As String, ByVal Target As String, Optional ByVal SortDirection As Integer = 0, Optional ByVal St As Integer = 0, Optional ByVal En As Integer = -1) As Integer
        If En = -1 Then En = UBound(Arr)
        ' شرط توقف: العثور على عنصر البحث في خانة البداية أو النهاية
        If Arr(St) = Target Then Return St
        If Arr(En) = Target Then Return En

        Dim Mdl As Integer = (St + En + 1) \ 2

        'شرط توقف: العثور على نصّ البحث في خانة المنتصف
        If Arr(Mdl) = Target Then
            Return Mdl
        ElseIf (SortDirection = 1) Xor (Arr(Mdl) < Target) Then
            If En - Mdl < 2 Then Return -(Mdl + 1)
            ' البحث في الجزء الأخير من المصفوفة الحاليّة
            St = Mdl + 1
            En -= 1
            ' نتيجة البحث هي
            ' الناتجة عن البحث في الجزء الأخير من المصفوفة
            Return BinarySearch2(Arr, Target, SortDirection, St, En)
        Else
            If Mdl - St < 2 Then Return -Mdl
            ' البحث في الجزء الأوّل من المصفوفة الحاليّة
            St += 1
            En = Mdl - 1
            ' نتيجة البحث هي
            '  تلك الناتجة عن البحث في النصف الأوّل من المصفوفة
            Return BinarySearch2(Arr, Target, SortDirection, St, En)
        End If
    End Function


    Sub Main()
        Dim S() As String = {"Mohammad", "Ahmad", "Ali", _
                                      "Hala", "Noha", "Hend"}
        QuickSort(S) ' يجب ترتيب المصفوفة أولا
        Dim I As Integer = BinarySearch(S, "Ali", True)
        If I < 0 Then
            Console.WriteLine("Not Found")
        Else
            Console.WriteLine("Item Index Is " + Str(I))
        End If

        I = BinarySearch(S, "Maged", True)
        Console.WriteLine("Maged Comes Before " + S(-I))

        QuickSort(S, 1) ' ترتيب المصفوفة تنازليا
        I = BinarySearch2(S, "Ali", 1)
        If I < 0 Then
            Console.WriteLine("Not Found")
        Else
            Console.WriteLine("Item Index Is " + Str(I))
        End If


        Console.ReadLine()

    End Sub

End Module
