﻿Module Module1

    Sub QuickSort(ByRef Arr() As String)
        Dim LeftArr(), RightArr() As String
        Dim LAC, RAC As Integer
        '------------  ملء المصفوفتين الصغرى والكبرى------------------
        For C As Integer = 1 To UBound(Arr)
            If Arr(0) > Arr(C) Then
                ' انقل الخانة إلى المصفوفة الصغرى
                ' زيادة خانة على المصفوفة الصغرى مع الاحتفاظ بقيمها السابقة
                ReDim Preserve LeftArr(LAC)
                LeftArr(LAC) = Arr(C)
                ' بعد إضافة الخانة يجب زيادة المتغيّر المعبّر عن طول
                ' المصفوفة بواحد لنستخدمه لإضافة خانة في المرة التالية
                LAC += 1
            Else ' انقل الخانة إلى المصفوفة الكبرى
                ReDim Preserve RightArr(RAC)
                RightArr(RAC) = Arr(C)
                RAC += 1
            End If
        Next
        '--------------------استدعاء الإجراء لنفسه----------------------
        ' شرط التوقف عن ترتيب المصفوفة الصغرى أن تكون فارغة أو بها خانة واحدة
        If LAC > 1 Then QuickSort(LeftArr)
        ' شرط التوقف عن ترتيب المصفوفة الكبرى أن تتكون فارغة أو بها خانة واحدة
        If RAC > 1 Then QuickSort(RightArr)
        '----------نقل المصفوفتين المرتبتين إلى المصفوفة الأصليّة ------
        ' تأكّد إذا كانت المصفوفة الصغرى تحتوي على خانات
        If LAC > 0 Then
            ' ضع الخانة الأولى (المرجعيّة) بعد المصفوفة الصغرى
            'LAC ونحن نعرف طول المصفوفة الصغرى من المتغيّر
            Arr(LAC) = Arr(0)
            ' انسخ المصفوفة الصغرى إلى بداية المصفوفة الأصليّة
            LeftArr.CopyTo(Arr, 0)
        End If
        ' إذا كانت المصفوفة الكبرى تحتوي على خانات فانسخها
        ' (إلى نهاية المصفوفة الأصليّة، (بعد الخانة التي بها الخانة المرجعيّة
        If RAC Then RightArr.CopyTo(Arr, LAC + 1)
    End Sub

    Sub QuickSort2(ByRef Arr() As String)
        Dim L As Integer = UBound(Arr)
        ' المصفوفة الصغرى والكبرى لهما مبدئيّا نفس طول المصفوفة الأصليّة 
        Dim LeftArr(L), RightArr(L) As String
        Dim LAC, RAC As Integer

        For C As Integer = 1 To L
            If Arr(0) > Arr(C) Then
                ' لم نعد نحتاج إلى جملة تغيير حجم المصفوفة
                LeftArr(LAC) = Arr(C)
                LAC += 1
            Else
                ' لم نعد نحتاج إلى جملة تغيير حجم المصفوفة
                RightArr(RAC) = Arr(C)
                RAC += 1
            End If
        Next
        ' إعادة تغيير حجم المصفوفتين لإزالة الخانات الزائدة.. يجب طرح 1 من 
        ' طول كل مصفوفة لأننا أضفناه ليشير إلى خانة تالية لكن لم نضع فيها شيئا
        ReDim Preserve LeftArr(LAC - 1)
        ReDim Preserve RightArr(RAC - 1)

        If LAC > 1 Then QuickSort(LeftArr)
        If RAC > 1 Then QuickSort(RightArr)

        If LAC Then
            Arr(LAC) = Arr(0)
            LeftArr.CopyTo(Arr, 0)
        End If
        If RAC Then RightArr.CopyTo(Arr, LAC + 1)
    End Sub

    Sub QuickSort3(ByRef Arr() As String, Optional ByVal St As Integer = 0, Optional ByVal En As Integer = -1)
        If En = -1 Then En = UBound(Arr)
        Dim I As Integer, LAC As Integer = St, Temp As String
        For I = St + 1 To En
            ' لو غيّرت علامة (أصغر من) إلى (أكبر من)
            '  لتمّ الترتيب من الأكبر للأصغر
            If Arr(I) <= Arr(St) Then
                LAC += 1
                ' تبادل قيمتي الخانتين، إذا كانتا بالفعل خانتين مختلفتين
                If LAC <> I Then
                    Temp = Arr(LAC)
                    Arr(LAC) = Arr(I)
                    Arr(I) = Temp
                End If
            End If
        Next
        ' تبادل قيمتي الخانة المرجعيّة مع آخر أصغر رقم
        If LAC <> St Then
            Temp = Arr(LAC)
            Arr(LAC) = Arr(St)
            Arr(St) = Temp
        End If
        ' استدعاء الإجراء لنفسه.. لن نستدعي ترتيب المصفوفة الصغرى
        ' أو الكبرى إلا إذا كان بها خانتان على الأقلّ
        If LAC - St > 1 Then QuickSort3(Arr, St, LAC - 1)
        If En - LAC > 1 Then QuickSort3(Arr, LAC + 1, En)
    End Sub

    Sub QuickSort4(ByRef Arr() As String, Optional ByVal SortDirection As Integer = 0, Optional ByVal St As Integer = 0, Optional ByVal En As Integer = -1)
        If En = -1 Then En = UBound(Arr)
        Dim I As Integer, LAC As Integer = St, Temp As String
        For I = St + 1 To En
            If (SortDirection = 1) Xor (Arr(I) <= Arr(St)) Then
                LAC += 1
                ' تبادل قيمتي الخانتين، إذا كانتا بالفعل خانتين مختلفتين
                If LAC <> I Then
                    Temp = Arr(LAC)
                    Arr(LAC) = Arr(I)
                    Arr(I) = Temp
                End If
            End If
        Next
        ' تبادل قيمتي الخانة المرجعيّة مع آخر أصغر رقم
        If LAC <> St Then
            Temp = Arr(LAC)
            Arr(LAC) = Arr(St)
            Arr(St) = Temp
        End If
        If LAC - St > 1 Then
            QuickSort4(Arr, SortDirection, St, LAC - 1)
        End If
        If En - LAC > 1 Then
            QuickSort4(Arr, SortDirection, LAC + 1, En)
        End If
    End Sub

    Sub Main()
        Sort(1)
        Sort(2)
        Sort(3)
        Sort(4)
        Console.ReadLine()
    End Sub

    Sub Sort(ByVal Version As Integer)
        Dim S() As String = {"Mohammad", "Ahmad", "Ali", "Hala", "Noha", "Hend", "Mona", "Tamer", "Ramy"}
        Select Case Version
            Case 1
                QuickSort(S)
            Case 2
                QuickSort2(S)
            Case 3
                QuickSort3(S)
            Case 4
                QuickSort4(S)
        End Select

        For I As Integer = 0 To UBound(S)
            Console.WriteLine(S(I))
        Next
        Console.WriteLine("*****************************")
    End Sub
End Module
