﻿Module Module1
    ''' <summary>
    ''' سجل المنبه
    ''' يستخدم لإطلاق رنة تنبيه في الوقت الذي يريده المستخدم
    ''' </summary>
    ''' <remarks>هذا المنبه يصلح للعمل 
    ''' في تطبيقات الاختبار ونماذج الويندوز</remarks>
    Structure Clock
        Event Ring(ByVal Time As Date)
        Delegate Sub AllowStopHandler(ByRef Sender As Clock, ByRef StopClock As Boolean)
        Event AllowStop As AllowStopHandler

        ''' <summary>
        ''' تعيد الوقت الحالي
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        ReadOnly Property Time() As Date
            Get
                Return Now
            End Get
        End Property

        Private pRingTime As Date
        ''' <summary>
        ''' تقرأ أو تغير وقت الرنين
        ''' </summary>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Property RingTime() As Date
            Get
                Return pRingTime
            End Get
            Set(ByVal value As Date)
                pRingTime = value
            End Set
        End Property

        Private pEnabled As Boolean
        ''' <summary>
        ''' تفعل أو تعطل المنبه
        ''' <value>إذا جعلتها<c>True</c>يتم تفعيل المنبه، وإذا جعلتها <c>False</c>يتم تعطيله</value>
        ''' </summary>
        Property Enabled() As Boolean
            Get
                Return pEnabled
            End Get
            Set(ByVal value As Boolean)
                pEnabled = value
                If pEnabled Then Start()
            End Set
        End Property

        ''' <summary>
        ''' يقوم بتشغيل المنبه
        ''' </summary>
        ''' <remarks></remarks>
        Sub Start()
            pEnabled = True
            Do
                If DateDiff(DateInterval.Second, pRingTime, Now) = 0 Then
                    RaiseEvent Ring(Now)
                    pEnabled = False
                    Exit Sub
                End If
                ' إيقاف المنبه إذا طلب المستخدم ذلك
                Dim StopClock As Boolean = False
                RaiseEvent AllowStop(Me, StopClock)
                If StopClock OrElse pEnabled = False Then
                    pEnabled = False
                    Exit Sub
                End If
            Loop
        End Sub

        ''' <summary>
        ''' يقوم بإيقاف المنبه عن العمل
        ''' </summary>
        ''' <remarks></remarks>
        Sub [Stop]()
            pEnabled = False
        End Sub
    End Structure

    Sub Main()
        Dim Clc As Clock
        Clc.RingTime = DateAdd(DateInterval.Second, 5, Now)
        AddHandler Clc.Ring, AddressOf Clock_Ring
        AddHandler Clc.AllowStop, AddressOf Clock_AllowStop
        Clc.Start()

    End Sub

    ''' <summary>
    ''' يعرف الفعل الذي إذا قام به المستخدم يتم إيقاف المنبع عن العمل
    ''' </summary>
    ''' <param name="Sender">كائن المنبه الذي أطلق الحدث</param>
    ''' <param name="StopClock">معامل مرجعي إذا جعلت قيمته <c>True</c>يتم إيقاف المنبه</param>
    ''' <remarks></remarks>
    Sub Clock_AllowStop(ByRef Sender As Clock, ByRef StopClock As Boolean)
        If Console.KeyAvailable Then
            StopClock = True
            RemoveHandler Sender.Ring, AddressOf Clock_Ring
            RemoveHandler Sender.AllowStop, AddressOf Clock_AllowStop
        End If
    End Sub

    ''' <summary>
    ''' حدث الرنين.. يسمح لك بفعل ما تريد عندما يرن المنه
    ''' </summary>
    ''' <param name="Time">الوقت الحالي</param>
    ''' <remarks></remarks>
    Sub Clock_Ring(ByVal Time As Date)
        Console.WriteLine("It Is " + Time + " Press Any Key To Stop")
        Do
            Beep()
            If Console.KeyAvailable Then Exit Sub
        Loop
    End Sub
End Module
