﻿Module FileStruct

    Structure File
        ' هذا التعريف الجزئي يحتوي على الدوال الخاصة التي تستخدم داخل السجل فقط
        Private X As Integer

        Private Shared Function PathExists(ByVal Path As String) As Boolean
            Try
                GetAttr(Path)
            Catch ex As Exception
                If ex.Message Like "*not found*" Then Return False
            End Try
            Return True
        End Function
        ' هذا التعريف الجزئي يحتوي على الأعضاء العامة التي يمكن استدعاؤها من خارج السجل
        Shared Function Exists(ByVal Path As String) As Boolean
            Return PathExists(Path)
        End Function

        Shared Property Attributes(ByVal Path As String) As FileAttribute
            Get
                Return GetAttr(Path)
            End Get
            Set(ByVal value As FileAttribute)
                SetAttr(Path, value)
            End Set
        End Property

        Shared Function CopyFile(ByVal Path As String, ByVal NewPath As String) As String
            Try
                If PathExists(NewPath) Then
                    Dim ErrMsg As String = DeleteFile(NewPath)
                    If ErrMsg <> "" Then Return ErrMsg
                End If
                FileCopy(Path, NewPath)
                Return ""
            Catch Ex As Exception
                Return "Error In File " & Path & " : " & Ex.Message
            End Try
        End Function

        Shared Function MoveFile(ByVal Path As String, ByVal NewPath As String) _
                 As String
            Try
                If PathExists(NewPath) Then
                    Dim ErrMsg As String = DeleteFile(NewPath)
                    If ErrMsg <> "" Then Return ErrMsg
                End If
                Rename(Path, NewPath)
                Return ""
            Catch Ex As Exception
                Return "Error In File " & Path & " : " & Ex.Message
            End Try
        End Function

        Shared Function DeleteFile(ByVal Path As String) As String
            Try
                SetAttr(Path, FileAttribute.Normal)
                Kill(Path)
                Return ""
            Catch Ex As Exception
                Return "Error In File " & Path & " : " & Ex.Message
            End Try
        End Function

        Shared ReadOnly Property LastModified(ByVal Path As String) As Date
            Get
                Return FileDateTime(Path)
            End Get
        End Property


    End Structure

End Module
