﻿Module Module1

    Class Page
        Public Delegate Sub TextChangedHandler(ByVal Sender _
              As Page, ByVal NewText As String, ByRef Cancel As Boolean)

        Public Event TextChanged As TextChangedHandler
        Public Event ShowMessage(ByVal Sender As Page, ByVal Message As String)

        Sub New()
            RaiseEvent ShowMessage(Me, "Page Created")
        End Sub

        Sub New(ByVal ShowMsgHandler As ShowMessageEventHandler)
            AddHandler Me.ShowMessage, ShowMsgHandler
            RaiseEvent ShowMessage(Me, "Page Created")
        End Sub

        Dim pText As String
        Property Text() As String
            Get
                RaiseEvent ShowMessage(Me, "Reading Page Text")
                Return pText
            End Get

            Set(ByVal Value As String)
                Dim Cancel As Boolean = False
                RaiseEvent TextChanged(Me, value, Cancel)
                If Cancel Then Exit Property
                pText = value
                RaiseEvent ShowMessage(Me, "Page Text Changed")
            End Set
        End Property
    End Class

    Sub Page_TextChanged(ByVal Sender As Page, ByVal NewText As String, ByRef Cancel As Boolean)
        Select Case NewText
            Case "ESC"
                Cancel = True
            Case "DUP"
                Cancel = True
                Dim X As String = Sender.Text
                If X <> "" Then Sender.Text = X & X
            Case "DEL"
                Cancel = True
                Sender.Text = ""
        End Select
    End Sub

    Sub Page_Message(ByVal Sender As Page, ByVal Message As String)
        Console.WriteLine(Message)
    End Sub

    Dim WithEvents P2 As New Page

    Sub Main()
        Dim P As New Page(AddressOf Page_Message)
        AddHandler P.TextChanged, AddressOf Page_TextChanged

        Do
            Dim X As String = Console.ReadLine
            If X = "" Then
                Console.WriteLine(P.Text)
                Console.WriteLine(P2.Text)
                Exit Do
            End If

            P.Text += X
            P2.Text += X
        Loop
        Console.ReadLine()
    End Sub

    Private Sub P2_ShowMessage(ByVal Sender As Page, ByVal Message As String) Handles P2.ShowMessage
        Page_Message(Sender, "P2: " & Message)
    End Sub

    Private Sub P2_TextChanged(ByVal Sender As Page, ByVal NewText As String, ByRef Cancel As Boolean) Handles P2.TextChanged
        Page_TextChanged(Sender, NewText, Cancel)
    End Sub
End Module
