﻿Public Class Tree
    Public Value As String, Left, Right As Tree
    Enum TreeLocation
        LeftTree = 0
        RightTree = 1
    End Enum

    Sub New()
        MyBase.New()
    End Sub

    Sub New(ByRef A As String())
        AddBSTArray(A)
    End Sub

    Function Add(ByVal ItemValue As String, ByVal Location As  _
                    TreeLocation) As Tree
        Dim T As New Tree
        T.Value = ItemValue
        If Location = TreeLocation.LeftTree Then
            Left = T
        Else
            Right = T
        End If
        Return T
    End Function

    Shared Function SortTree(ByRef A As String()) As String()
        Dim T As New Tree(A)
        Return T.GetBSTArray
    End Function

    Sub AddBSTArray(ByRef A As String())
        If A Is Nothing OrElse A.Length = 0 Then Exit Sub
        Me.Value = A(0)
        For I As Integer = 1 To UBound(A)
            AddToBST(Me, A(I))
        Next
    End Sub

    Private Sub AddToBST(ByRef T As Tree, ByRef Item As String)
        If Item < T.Value Then
            If T.Left Is Nothing Then
                T.Add(Item, Tree.TreeLocation.LeftTree)
                Return
            Else ' ابحث في الفرع الأيسر عن موضع مناسب لهذا العنصر
                AddToBST(T.Left, Item)
            End If
        ElseIf T.Right Is Nothing Then
            T.Add(Item, Tree.TreeLocation.RightTree)
            Return
        Else ' ابحث في الفرع الأيمن عن موضع مناسب لهذا العنصر
            AddToBST(T.Right, Item)
        End If
    End Sub

    Function GetBSTArray() As String()
        Dim L As New LinkedList(Of String)
        ReadTree(Me, L)
        Return L.ToArray
    End Function

    Private Sub ReadTree(ByRef T As Tree, ByRef L As LinkedList(Of String))
        If T Is Nothing Then Return
        ReadTree(T.Left, L)
        L.Add(T.Value)
        ReadTree(T.Right, L)
    End Sub

End Class
