﻿Public Class Evaluator

    Dim pExpression As String

    Sub New(ByVal Expression As String)
        pExpression = Expression
    End Sub

    Property Expression() As String
        Get
            Return pExpression
        End Get
        Set(ByVal value As String)
            pExpression = value
        End Set
    End Property
    Function GetValue(ByVal Value As Double) As Double
        Try
            Dim S As String = Replace(pExpression, "x", Value)
            S = Replace(S, "X", Value)
            S = Replace(S, "س", Value)
            Return ExecuteParentheses(GetTokens(S))
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Function


    Private Function GetTokens(ByVal S As String) As LinkedList(Of String)
        S = S.Replace(" ", "")
        Dim Tokens As New LinkedList(Of String)
        Dim LastPos As Integer, Token As String
        For Pos As Integer = 1 To Len(S)
            Token = Mid(S, Pos, 1)
            If Not IsNumeric(Token) Then
                If Pos - LastPos > 1 Then
                    Tokens.Add(Mid(S, LastPos + 1, Pos - LastPos - 1))
                End If
                Tokens.Add(Token)
                LastPos = Pos
            End If
        Next
        If LastPos < Len(S) Then
            Tokens.Add(Mid(S, LastPos + 1, Len(S) - LastPos))
        End If
        Return Tokens
    End Function

    Private Function ExecuteParentheses(ByVal Tokens As LinkedList(Of String)) As Double
        Dim PStack As New Stack(Of String), Token As String
        If Tokens.MoveFirst() Then
            Do
                Token = Tokens.CurItem
                If Token = ")" Then
                    PStack.Push(ExecP(PStack))
                Else
                    PStack.Push(Token)
                End If
            Loop While (Tokens.MoveNext())
            If PStack.Count = 1 Then
                ' رصة الأقواس تحتوي على عنصر واحد فقط
                ' لا بد أن هذا العنصر ناتج آخر عملية حسابية تم إجراؤها
                Return PStack.Peek
            Else ' رصة الأقواس تحتوي على عدة عناصر يجب حسابها                
                Return ExecP(PStack)
            End If
        End If
    End Function

    ' دالة مساعدة لدالة الأقواس
    '  تنقل العناصر الموجودة بين القوسين إلى رصة الحساب
    Private Function ExecP(ByRef PStack As Stack(Of String)) As String
        Dim AStack As New Stack(Of String)
        Dim Token As String
        Do Until PStack.IsEmpty
            Token = PStack.Pop
            If Token = "(" Then Exit Do
            AStack.Push(Token)
        Loop
        Return CalculateMulDiv(AStack)
    End Function

    Private Function CalculateMulDiv(ByRef AStack As Stack(Of String)) As Double
        Dim RStack As New Stack(Of String)
        Dim Token As String
        Do Until AStack.IsEmpty
            Token = AStack.Pop
            Select Case Token
                Case "×", "*"
                    RStack.Peek *= AStack.Pop
                Case "÷", "/"
                    RStack.Peek /= AStack.Pop
                Case Else
                    RStack.Push(Token)
            End Select
        Loop
        Return CalculateSumSub(RStack)
    End Function

    Private Function CalculateSumSub(ByRef AStack As Stack(Of String)) As Double
        ' عكس الرصة 
        Dim A() As String = AStack.ToArray
        AStack.Clear()
        For I As Integer = UBound(A) To 0 Step -1
            AStack.Push(A(I))
        Next

        Dim RStack As New Stack(Of String)
        Dim Token As String
        Do Until AStack.IsEmpty
            Token = AStack.Pop
            Select Case Token
                Case "+"
                    RStack.Peek += CInt(AStack.Pop)
                Case "-"
                    RStack.Peek -= AStack.Pop
                Case Else
                    RStack.Push(Token)
            End Select
        Loop
        Return RStack.Peek
    End Function

End Class
