﻿Class Stack(Of SType)
    Dim SList As New LinkedList(Of SType)

    ReadOnly Property Count() As Integer
        Get
            Return SList.Count
        End Get
    End Property

    Sub Push(ByVal Item As SType)
        SList.Add(Item)
    End Sub

    Function Pop() As SType
        If SList.Count = 0 Then
            Throw New Exception("الرصة فارغة")
        End If
        Pop = SList.LastItem
        SList.RemoveLastItem()
    End Function

    ReadOnly Property IsEmpty() As Boolean
        Get
            Return (SList.Count = 0)
        End Get
    End Property

    Property Peek() As SType
        Get
            If SList.Count = 0 Then
                Throw New Exception("الرصة فارغة")
            End If
            Return SList.LastItem
        End Get
        Set(ByVal Value As SType)
            If SList.Count = 0 Then
                Throw New Exception("الرصة فارغة")
            End If
            SList.LastItem = Value
        End Set
    End Property

    Function ToArray() As SType()
        Return SList.ToArray
    End Function

    Sub Clear()
        SList.Clear()
    End Sub

    Sub DropBottom()
        SList.RemoveAt(0)
    End Sub

    Public Shared Widening Operator CType(ByVal S1 As Stack _
            (Of SType)) As LinkedList(Of SType)
        Return S1.SList
    End Operator

    Public Shared Widening Operator CType(ByVal L1 As  _
             LinkedList(Of SType)) As Stack(Of SType)
        Dim S1 As New Stack(Of SType)
        S1.SList = L1
        Return S1
    End Operator

End Class
