﻿Class Queue(Of QType)
    Dim QList As New LinkedList(Of QType)

    ReadOnly Property Length() As Integer
        Get
            Return QList.Count
        End Get
    End Property

    ReadOnly Property IsEmpty() As Boolean
        Get
            Return (QList.Count = 0)
        End Get
    End Property

    Property Peek() As QType
        Get
            If QList.Count = 0 Then
                Throw New Exception("الطابور فارغ")
            End If
            Return QList(0)
        End Get
        Set(ByVal Value As QType)
            If QList.Count = 0 Then
                Throw New Exception("الطابور فارغ")
            End If
            QList(0) = Value
        End Set
    End Property

    Sub Enqueue(ByVal Item As QType)
        QList.Add(Item)
    End Sub

    Function Dequeue() As QType
        If QList.Count = 0 Then
            Throw New Exception("الطابور فارغ")
        End If
        Dequeue = QList(0) ' القيمة العائدة 
        QList.RemoveAt(0)
    End Function

    Function ToArray() As QType()
        Return QList.ToArray()
    End Function

    Sub Clear()
        QList.Clear()
    End Sub

    Public Shared Widening Operator CType(ByVal Q1 As  _
            Queue(Of QType)) As LinkedList(Of QType)
        Return Q1.QList
    End Operator

    Public Shared Widening Operator CType(ByVal L1 As  _
            LinkedList(Of QType)) As Queue(Of QType)
        Dim Q1 As New Queue(Of QType)
        Q1.QList = L1
        Return Q1
    End Operator

    Public Shared Widening Operator CType(ByVal S1 As Stack _
            (Of QType)) As Queue(Of QType)
        Dim Q1 As New Queue(Of QType)
        Q1.QList = S1
        Return Q1
    End Operator

End Class
