﻿
Class BSTTree(Of ArrType As IComparable)
    Dim T As New Tree(Of Cell)

    Public Sub New(ByRef A As ArrType())
        AddBSTArray(A)
    End Sub

    Private Sub AddBSTArray(ByRef A As ArrType())
        If A Is Nothing OrElse A.Length = 0 Then Exit Sub
        T.Value = New Cell(A(0), 0)
        For I As Integer = 1 To UBound(A)
            AddToBST(T, New Cell(A(I), I))
        Next
    End Sub

    Private Sub AddToBST(ByVal T As Tree(Of Cell), ByRef Item As Cell)
        If Item.CompareTo(T.Value) = -1 Then
            If T.Left Is Nothing Then
                T.Add(Item, Tree(Of Cell).TreeLocation.LeftTree)
                Return
            Else ' ابحث في الفرع الأيسر عن موضع مناسب لهذا العنصر
                AddToBST(T.Left, Item)
            End If
        ElseIf T.Right Is Nothing Then
            T.Add(Item, Tree(Of Cell).TreeLocation.RightTree)
            Return
        Else ' ابحث في الفرع الأيمن عن موضع مناسب لهذا العنصر
            AddToBST(T.Right, Item)
        End If
    End Sub

    Function GetSortedArray() As ArrType()
        Dim L As New LinkedList(Of ArrType)
        ReadTree(T, L)
        Return L.ToArray
    End Function

    Private Sub ReadTree(ByRef T As Tree(Of Cell), ByRef L As LinkedList(Of ArrType))
        If T Is Nothing Then Return
        ReadTree(T.Left, L)
        L.Add(T.Value.Value)
        ReadTree(T.Right, L)
    End Sub

    Function Find(ByVal Item As ArrType) As Integer
        Return SearchTree(T, Item)
    End Function

    Private Function SearchTree(ByRef T As Tree(Of Cell), ByVal Item As ArrType) As Integer
        Select Case Item.CompareTo(T.Value.Value)
            Case 0
                Return T.Value.Index
            Case -1  ' ابحث في الفرع الأيسر عن هذا العنصر
                If T.Left Is Nothing Then Return -1
                Return SearchTree(T.Left, Item)
            Case Else ' ابحث في الفرع الأيمن عن هذا العنصر
                If T.Right Is Nothing Then Return -1
                Return SearchTree(T.Right, Item)
        End Select
    End Function

    Private Class Cell : Implements IComparable
        Public Value As ArrType
        Public Index As Integer

        Sub New()
            MyBase.New()
        End Sub

        Sub New(ByVal Value As ArrType, ByVal Index As Integer)
            Me.Value = Value
            Me.Index = Index
        End Sub

        Public Function CompareTo(ByVal other As Object) As Integer Implements System.IComparable.CompareTo
            Return Me.Value.CompareTo(CType(other, Cell).Value)
        End Function
    End Class

End Class

