﻿Class Stack(Of SType)
    Dim S() As SType
    Private pCapacity As Integer
    Const CapacityIncrease = 50

    Sub New()
        pCapacity = CapacityIncrease
        ReDim S(pCapacity - 1)
        pCount = 0
    End Sub

    Sub New(ByVal InitialCapacity As Integer)
        pCapacity = InitialCapacity
        If pCapacity < 1 Then pCapacity = CapacityIncrease
        ReDim S(pCapacity - 1)
        pCount = 0
    End Sub


    Dim pCount As Integer
    ReadOnly Property Count() As Integer
        Get
            Return pCount
        End Get
    End Property

    Sub Push(ByVal Item As SType)
        pCount += 1
        If pCount > pCapacity Then
            pCapacity += CapacityIncrease
            ReDim Preserve S(pCapacity - 1)
        End If
        S(pCount - 1) = Item
    End Sub

    Function Pop() As SType
        If pCount = 0 Then Throw New Exception("الرصة فارغة")
        pCount -= 1
        DecreaseCapacity()
        Return S(pCount)
    End Function

    Private Function DecreaseCapacity() As SType
        If pCapacity - pCount > 100 Then
            pCapacity -= 50
            ReDim Preserve S(pCapacity)
        End If
    End Function

    ReadOnly Property IsEmpty() As Boolean
        Get
            Return (pCount = 0)
        End Get
    End Property


    Property Peek() As SType
        Get
            If pCount = 0 Then
                Throw New Exception("الرصة فارغة")
            End If
            Return S(pCount - 1)
        End Get

        Set(ByVal Value As SType)
            If pCount = 0 Then
                Throw New Exception("الرصة فارغة")
            End If
            S(pCount - 1) = Value
        End Set
    End Property

    Function ToArray() As SType()
        If pCount = 0 Then Return Nothing
        Dim A(pCount - 1) As SType
        For I As Integer = 0 To pCount - 1
            A(I) = S(I)
        Next
        Return A
    End Function

    Sub Clear()
        pCount = 0
        DecreaseCapacity()
    End Sub
End Class
