﻿Module Polymorphism

    Public MustInherit Class Shape
        MustOverride Function GetArea() As Double      
        MustOverride ReadOnly Property Perimeter() As Double

        Public Sub ShowArea()
            MsgBox(CStr(GetArea))
        End Sub

        Sub Dispose()
            GC.SuppressFinalize(Me)
        End Sub

    End Class

    Public Class Rectangle : Inherits Shape
        Sub New()
            MyBase.New()
        End Sub
        Sub New(ByVal Length As Double, ByVal Width As Double)
            MyBase.New()
            Me.Length = Length
            Me.Width = Width
        End Sub

        Private pLength As Double
        Public Property Length() As Double
            Get
                Return pLength
            End Get

            Set(ByVal Value As Double)
                pLength = Value
            End Set
        End Property

        Private pWidth As Double
        Public Overridable Property Width() As Double
            Get
                Return pWidth
            End Get
            Set(ByVal Value As Double)
                pWidth = Value
            End Set
        End Property

        Public Overrides Function GetArea() As Double
            Return pLength * Width
        End Function

        Public Overrides ReadOnly Property Perimeter() As Double
            Get
                Return 2 * (pLength + Width)
            End Get
        End Property
    End Class

    Public Class Square : Inherits Rectangle
        Public Overrides Property Width() As Double
            Get
                Return Length ' العرض يساوي الطول
            End Get
            Set(ByVal value As Double)
                Length = value ' العرض يساوي الطول 
            End Set
        End Property

    End Class

    Public Class Triangle : Inherits Shape
        Public L1, L2, L3 As Double

        Public Overrides Function GetArea() As Double
            Dim X As Double
            X = (L3 ^ 2 - ((L1 ^ 2 + L3 ^ 2 - L2 ^ 2) / (2 * L1)) ^ 2) ^ 0.5
            Return X * L1 / 2
        End Function

        Public Overrides ReadOnly Property Perimeter() As Double
            Get
                Return (L1 + L2 + L3)
            End Get
        End Property
    End Class

    Public Class Circle : Inherits Shape

        ' منشئ بدون معاملات
        Sub New()
            MyBase.New()
        End Sub
        ' منشئ يتلقى نصف القطر
        Sub New(ByVal Radius As Double)
            MyBase.New()
            Me.Radius = Radius
        End Sub
        ' منشئ يتلقى المربّع الذي يحتوي الدائرة
        Sub New(ByVal OuterSquare As Square)
            Me.New(OuterSquare.Width / 2)
        End Sub

        Public Radius As Double

        Public Overrides Function GetArea() As Double
            Return Math.PI * Radius ^ 2
        End Function

        Public Overrides ReadOnly Property Perimeter() As Double
            Get
                Return 2 * Math.PI * Radius
            End Get
        End Property
    End Class

End Module

