﻿Public MustInherit Class Record(Of RType As Structure)
    Dim RecLen As Integer = Len(New RType)
    ReadOnly Property RecordLength() As Integer
        Get
            Return RecLen
        End Get
    End Property

    Public MustOverride Sub Close()

    Public MustOverride Function ReadRecord(Optional ByVal _
               RecNo As Long = -1) As RType
    Public MustOverride Sub Read(ByRef R() As RType, _
              Optional ByVal RecNo As Long = -1, Optional ByVal _
              St As Integer = 0, Optional ByVal Count As Integer = 1)
    Public MustOverride Sub WriteRecord(ByVal R As RType, _
              Optional ByVal RecNo As Long = -1)
    Public MustOverride Sub Write(ByVal R() As RType, _
             Optional ByVal RecNo As Long = -1, Optional ByVal _
             St As Integer = 0, Optional ByVal Count As Integer = 1)
    Enum SeekOrigin
        Begin = 0
        Current = 1
        [End] = 2
    End Enum


    Public Function Seek(ByVal Offset As Long, Optional ByVal _
                   origin As SeekOrigin = SeekOrigin.Current) As Long
        Dim Pos As Long
        Select Case origin
            Case SeekOrigin.Begin
                Pos = Offset
            Case SeekOrigin.Current
                Pos = Position + Offset
            Case Else 'SeekOrigin.End 
                Pos = Length - 1 + Offset
        End Select
        If Pos >= Length OrElse Pos < 0 Then
            Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
        End If
        Position = Pos
        Return Pos
    End Function

    Protected pCanRead As Boolean = True
    Public MustOverride ReadOnly Property CanRead() _
                As Boolean
    Protected pCanWrite As Boolean = True
    Public MustOverride ReadOnly Property CanWrite() _
                As Boolean
    Public MustOverride ReadOnly Property Length() As Long
    Public MustOverride Property Position() As Long
    Default Property Item(ByVal RecNo As Integer) As RType
        Get
            Dim Pos As Long = Position
            Item = ReadRecord(RecNo)
            Position = Pos ' هذه الخاصية لا تغير الموضع الحالي
        End Get
        Set(ByVal value As RType)
            Dim Pos As Long = Position
            WriteRecord(value, RecNo)
            Position = Pos
        End Set
    End Property
End Class
