﻿
Public Class StringReader : Inherits TextReader
    Dim S As String, pLength, pPosition As Long
    Sub New(ByVal Str As String)
        S = Str : pLength = Len(Str) : pPosition = 0
    End Sub

    Public Overrides Sub Close()
        S = ""
    End Sub

    Public Overrides Function ReadChar() As Char
        If pPosition >= pLength Then Return Nothing
        Return Mid(S, pPosition, 1)
        pPosition += 1
    End Function

    Public Overrides Function ReadString(ByVal Count As Integer) As String
        If pPosition >= pLength Then Return ""
        If pPosition + Count > pLength Then
            Count = pLength - pPosition
        End If
        ReadString = Mid(S, pPosition + 1, Count)
        pPosition += Count
    End Function

     Public Overrides Function Seek(ByVal Offset As Long, _
               Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long
        Dim Pos As Long
        Select Case origin
            Case SeekOrigin.Begin
                Pos = Offset
            Case SeekOrigin.Current
                Pos = pPosition + Offset
            Case Else 'SeekOrigin.End 
                Pos = pLength - 1 + Offset
        End Select
        If Pos >= pLength OrElse Pos < 0 Then Return -1
        pPosition = Pos
        Return Pos
    End Function

    Public Overrides ReadOnly Property Length() As Long
        Get
            Return pLength
        End Get
    End Property

    Public Overrides Property Position() As Long
        Get
            Return pPosition
        End Get
        Set(ByVal Pos As Long)
            If Pos >= pLength OrElse Pos < 0 Then
                Throw New Exception("لا يمكن الانتقال إلى هذا الموضع")
            End If
            pPosition = Pos
        End Set
    End Property

    Public Overrides Function ToString() As String
        Return S
    End Function

    Public Function ToArray() As Char()
        Return S.ToCharArray
    End Function
End Class
