﻿Imports VB = Microsoft.VisualBasic

Class BitBuffer
    Dim BA As BitArray, Fs As FileStream, InitialValue As Byte

    Sub New(ByVal File As FileStream, _
                    Optional ByVal InitialValue As Byte = 0)
        Fs = File : BA = New BitArray(InitialValue)
        Me.InitialValue = InitialValue
    End Sub

    Dim pPossition As Integer
    ReadOnly Property Possition() As Integer
        Get
            Return pPossition
        End Get
    End Property

    Function GetByte() As Byte
        Return BA
    End Function

    Sub Flush()
        Fs.WriteByte(BA) : BA = InitialValue : pPossition = 0
    End Sub

    Private Sub AddBit(ByVal Bit As Byte)
        BA(7 - pPossition) = Bit : pPossition += 1
        If pPossition = 8 Then Flush()
    End Sub

    Sub Add(ByVal Bits As Byte, Optional ByVal BitsNo As Byte = 1)
        If BitsNo < 2 AndAlso Bits < 2 Then AddBit(Bits) : Return
        Dim N As Single ' حساب عدد الخانات اللازمة
        If Bits < 2 Then
            N = 1
        Else : N = Math.Log10(Bits) / Math.Log10(2)
            If N <> Int(N) Then N = Int(N) + 1
        End If
        If N > BitsNo Then BitsNo = N
        Dim BitConverter As New BitArray(Bits) ' تمثيل العدد ثنائيا
        Dim S As String = BitConverter
        If BitsNo < 8 Then S = VB.Right(S, BitsNo)
        For I As Integer = 1 To BitsNo
            AddBit(CByte(Mid(S, I, 1)))
        Next
    End Sub

    ReadOnly Property IsEmpty() As Boolean
        Get
            Return (pPossition = 0)
        End Get
    End Property

End Class
